Description

I create a lot of vmware vm's in foreman that generally end up getting turned off after creation to prep for ova export.  Id like to be

able to provision them in forman and the delete the host in foreman; without actually deleting the vmware vm.

I found the following article:

https://groups.google.com/forum/#!topic/foreman-users/BES0qnmw9XE

which mentions editing compute.rb.  I made edits to actually check if the entry in the database is managed or not before destroying, 

but  it appears the host.destroy function actually deletes the db record before calling delCompute.  Im not good enough with rails to

follow the destroy chain to figure out where an edit needs to be placed to implement this.  Ideally it would be a configurable option.

Thanks.

Related issues:

Related to Foreman - Feature #3909: compute resources prevent or disassciate ... Closed 12/18/2013

History

#1 - 04/27/2014 01:16 AM - Trey Ormsbee

I meant to post this as a feature request,  not a bug report.  Sorry.

#2 - 04/28/2014 07:37 AM - Dominic Cleal

- Status changed from New to Feedback

Foreman 1.5 has a "disassociate" button on hosts which will unlink it from the VM, allowing you to then delete the host without destroying the VM. 

Although it's not part of the destroy workflow, maybe it solves this for you?

#3 - 04/28/2014 07:38 AM - Dominic Cleal

- Related to Feature #3909: compute resources prevent or disassciate host from VM prevent vm deletion added

#4 - 04/28/2014 02:54 PM - Trey Ormsbee

Dominic Cleal wrote:

Foreman 1.5 has a "disassociate" button on hosts which will unlink it from the VM, allowing you to then delete the host without destroying the

VM.  Although it's not part of the destroy workflow, maybe it solves this for you?

 That should work perfectly.  Thank you!

#5 - 04/28/2014 03:17 PM - Dominic Cleal

- Status changed from Feedback to Duplicate

Great, give it a try once 1.5.0-RC2's available as we fixed a bug.

05/11/2024 1/2
#6 - 04/28/2014 04:38 PM - Trey Ormsbee

I tried upgrading on a test box, and am having trouble getting it working (lots o DB errors)....  but looking at the controller code it will do exactly what I

need. Ill keep an eye out and try when rc3 hits and give it a try...

def disassociate

    if @host.uuid.nil? && @host.compute_resource_id.nil?

      process_error :error_msg => _("Host %s is not associated with a VM") % @host.name, :redirect => :back

    else

      @host.uuid = nil

      @host.compute_resource_id = nil

      @host.save!(:validate => false) # don't want to trigger callbacks

      msg = _("%s has been disassociated from VM") % (@host.name)

      process_success :success_msg => msg, :success_redirect => :back

    end

  end

#7 - 04/28/2014 04:50 PM - Dominic Cleal

I'd suggest posting to the -users list or popping on IRC if you're having upgrade problems, I'm not aware of any major DB errors so perhaps we can

help you solve them.

#8 - 04/28/2014 08:48 PM - Trey Ormsbee

I got it working,  I installed from rpm's first,  then just pulled from git.  I think I had other issues such as gem versioning. The functionality I am looking

for is attained 100% with the disassociate host function.  Thank you!
